<script setup>
import GData from 'ui/items/gdata.vue';
import { computed, onUpdated, ref } from 'vue';
import { useRollOver } from '../../store/popups';
import { positionAt } from './popups';

const popupStore = useRollOver();

const item = computed(() => popupStore.rollOver.item);
const title = computed(() => popupStore.rollOver.title);
const text = computed(() => popupStore.rollOver.text);

const popupRef = ref();

/**
 * Box for displaying item information.
 */
onUpdated(() => {

	const elm = popupStore.rollOver.elm;

	// wait for width to change before reposition.
	if (elm && item.value) {
		positionAt(popupRef.value, elm);
	}

});

const updated = () => {
	// waiting for width to change before reposition.
	if (item.value || title.value) {
		positionAt(popupRef.value, popupStore.rollOver.elm);
		//this fixes "Tooltip too long" by applying a column style to any window that's a bit too tall.
		//The reason for the default setters, is that without them, iteminfo gets an incorrect height.
		const popup = document.getElementsByClassName("item-popup")[0];
		popup.style["column-count"] = "auto";
		popup.style["column-width"] = "auto";
		popup.style["max-width"] = "280px";
		const positionInfo = popup.getBoundingClientRect();

		if (positionInfo.height >= window.innerHeight * 0.85) {
			const iteminfo = document.getElementsByClassName("popup-content")[0];
			const colCount = Math.ceil(iteminfo.getBoundingClientRect().height / (window.innerHeight * 0.95));
			const maxwidth = colCount * 300 + "px"
			popup.style["column-width"] = 280 + "px"
			popup.style["column-count"] = colCount
			popup.style["max-width"] = maxwidth
		}
	}
}
</script>


<template>

	<div class="item-popup" ref="popupRef"
		v-show="item != null || text != null">
		<div class="popup-content">
		<div v-if="title" class="pop-title">{{ title }}</div>
		<template v-if="Array.isArray(item)">

			<div v-for="t in item" :key="t">{{ t.toString() }}</div>

		</template>
		<template v-else>
			<GData v-if="item" :item="item" />
		</template>
		<template v-if="text">
			<div>{{ text }}</div>
		</template>
		</div>
	</div>

</template>

<style scoped>
div.pop-title {

	font-weight: bold;
	border-bottom: 1px solid black;
	margin-bottom: var(--md-gap);

}


.popup-content {
	padding: var(--md-gap);
}
</style>